## injeqt 1.0.1

=== CMakeLists.txt ===
#
# %injeqt copyright begin%
# Copyright 2014 Rafał Malinowski (rafal.przemyslaw.malinowski@gmail.com)
# %injeqt copyright end%
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

project (injeqt)
cmake_minimum_required (VERSION 2.8)

set (INJEQT_SOVERSION "0")
set (INJEQT_VERSION "1.0.1")

option (DISABLE_TESTS "Do not build tests" OFF)
option (DISABLE_EXAMPLES "Do not build examples" OFF)

find_package (Qt5Core 5.2 REQUIRED)

# do not link with qtmain on windows
if (POLICY CMP0020)
	cmake_policy (SET CMP0020 OLD)
endif ()
if (POLICY CMP0043)
	cmake_policy (SET CMP0043 NEW)
endif ()

set (WARNINGS "-Werror -W -Wall -Wextra -Wundef -Wunused -Wuninitialized -Wcast-align -Wpointer-arith -Woverloaded-virtual -Wnon-virtual-dtor -fno-common")
set (VISIBILITY "-fvisibility=hidden -fvisibility-inlines-hidden")
set (CMAKE_CXX_FLAGS "-std=c++11 ${WARNINGS} ${VISIBILITY}")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
	set (CMAKE_CXX_FLAGS "-O0 ${CMAKE_CXX_FLAGS}")
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

set (CMAKE_AUTOMOC TRUE)
set (CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories (
	${CMAKE_CURRENT_SOURCE_DIR}/include
	${CMAKE_CURRENT_SOURCE_DIR}/src/internal
)

add_subdirectory (src)

if (NOT DISABLE_EXAMPLES)
	add_subdirectory (examples)
endif (NOT DISABLE_EXAMPLES)

if (NOT DISABLE_TESTS)
	enable_testing ()
	add_subdirectory (test)
endif (NOT DISABLE_TESTS)

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	set (CMAKE_INSTALL_LIBDIR lib)
endif (NOT DEFINED CMAKE_INSTALL_LIBDIR)

set (prefix ${CMAKE_INSTALL_PREFIX})
set (exec_prefix ${CMAKE_INSTALL_PREFIX})
set (libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set (includedir ${CMAKE_INSTALL_PREFIX}/include)
set (LIBS "-lQt5Core")

configure_file (
	${CMAKE_CURRENT_SOURCE_DIR}/injeqt.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/injeqt.pc
	@ONLY
)

install (DIRECTORY
	include/injeqt DESTINATION include
)

install (FILES
	${CMAKE_CURRENT_BINARY_DIR}/injeqt.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/CMakeLists.txt ===
#
# %injeqt copyright begin%
# Copyright 2014 Rafał Malinowski (rafal.przemyslaw.malinowski@gmail.com)
# %injeqt copyright end%
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

set (INJEQT_SRCS
	injector.cpp
	module.cpp
	type.cpp

	exception/ambiguous-types.cpp
	exception/default-constructor-not-found.cpp
	exception/dependency-duplicated.cpp
	exception/dependency-on-self.cpp
	exception/dependency-on-subtype.cpp
	exception/dependency-on-supertype.cpp
	exception/empty-type.cpp
	exception/exception.cpp
	exception/instantiation-failed.cpp
	exception/interface-not-implemented.cpp
	exception/invalid-dependency.cpp
	exception/invalid-qobject.cpp
	exception/invalid-setter.cpp
	exception/qobject-type.cpp
	exception/unavailable-required-types.cpp
	exception/unknown-type.cpp
	exception/unique-factory-method-not-found.cpp
	exception/unresolvable-dependencies.cpp

	internal/default-constructor-method.cpp
	internal/dependencies.cpp
	internal/dependency.cpp
	internal/factory-method.cpp
	internal/implementation.cpp
	internal/implemented-by.cpp
	internal/injector-core.cpp
	internal/injector-impl.cpp
	internal/interfaces-utils.cpp
	internal/module-impl.cpp
	internal/provider-by-default-constructor.cpp
	internal/provider-by-default-constructor-configuration.cpp
	internal/provider-by-factory.cpp
	internal/provider-by-factory-configuration.cpp
	internal/provider-ready.cpp
	internal/provider-ready-configuration.cpp
	internal/required-to-instantiate.cpp
	internal/resolved-dependency.cpp
	internal/resolve-dependencies.cpp
	internal/setter-method.cpp
	internal/type-dependencies.cpp
	internal/type-relations.cpp
	internal/types-by-name.cpp
	internal/types-model.cpp
)

add_definitions (
	-Dinjeqt_EXPORTS
)

add_library (
	injeqt
	SHARED
	${INJEQT_SRCS}
)

qt5_use_modules (injeqt
	LINK_PUBLIC Core
)

set_target_properties (injeqt PROPERTIES
	SOVERSION "${INJEQT_SOVERSION}"
	VERSION "${INJEQT_VERSION}"
)

if (NOT WIN32)
	include (GNUInstallDirs)
endif ()

install (TARGETS
	injeqt
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== test/CMakeLists.txt ===
#
# %injeqt copyright begin%
# Copyright 2014 Rafał Malinowski (rafal.przemyslaw.malinowski@gmail.com)
# %injeqt copyright end%
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

find_package (Qt5Test 5.2 REQUIRED)

option (DISABLE_COVERAGE "Do not gather coverage data" OFF)

include_directories (
	${CMAKE_SOURCE_DIR}/src
)

if (NOT DISABLE_COVERAGE)
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
	set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -O0")

	add_custom_target (coverage
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/coverage.sh
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endif (NOT DISABLE_COVERAGE)

function (injeqt_add_test name_)
	file (RELATIVE_PATH sourcePath "${CMAKE_SOURCE_DIR}/test" "${CMAKE_CURRENT_SOURCE_DIR}")

	get_filename_component (exeDir "${CMAKE_CURRENT_BINARY_DIR}/${name_}" PATH)
	file (MAKE_DIRECTORY "${exeDir}")

	add_executable (${name_} ${ARGN})
	set_property (TARGET ${name_} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error")
	qt5_use_modules (${name_} Core Test)

	if (NOT DISABLE_COVERAGE)
		target_link_libraries (${name_} gcov)
	endif (NOT DISABLE_COVERAGE)

	add_test ("${sourcePath}/${name_}" ${name_})
endfunction ()

function (injeqt_add_unit_test)
	injeqt_add_test (${ARGV})
endfunction ()

function (injeqt_add_integration_test name_)
	injeqt_add_test (${ARGV})
	target_link_libraries (${name_} injeqt)
endfunction ()

injeqt_add_unit_test (default-constructor-method-test unit/default-constructor-method-test.cpp)
injeqt_add_unit_test (dependencies-test unit/dependencies-test.cpp)
injeqt_add_unit_test (dependency-test unit/dependency-test.cpp)
injeqt_add_unit_test (factory-method-test unit/factory-method-test.cpp)
injeqt_add_unit_test (implementation-test unit/implementation-test.cpp)
injeqt_add_unit_test (implemented-by-test unit/implemented-by-test.cpp)
injeqt_add_unit_test (injector-core-test unit/injector-core-test.cpp)
injeqt_add_unit_test (injector-test unit/injector-test.cpp)
injeqt_add_unit_test (interfaces-utils-test unit/interfaces-utils-test.cpp)
injeqt_add_unit_test (module-impl-test unit/module-impl-test.cpp)
injeqt_add_unit_test (module-test unit/module-test.cpp)
injeqt_add_unit_test (provider-by-default-constructor-test unit/provider-by-default-constructor-test.cpp)
injeqt_add_unit_test (provider-by-default-constructor-configuration-test unit/provider-by-default-constructor-configuration-test.cpp)
injeqt_add_unit_test (provider-by-factory-test unit/provider-by-factory-test.cpp)
injeqt_add_unit_test (provider-by-factory-configuration-test unit/provider-by-factory-configuration-test.cpp)
injeqt_add_unit_test (provider-ready-test unit/provider-ready-test.cpp)
injeqt_add_unit_test (provider-ready-configuration-test unit/provider-ready-configuration-test.cpp)
injeqt_add_unit_test (required-to-instantiate-test unit/required-to-instantiate-test.cpp)
injeqt_add_unit_test (resolved-dependency-test unit/resolved-dependency-test.cpp)
injeqt_add_unit_test (resolve-dependencies-test unit/resolve-dependencies-test.cpp)
injeqt_add_unit_test (setter-method-test unit/setter-method-test.cpp)
injeqt_add_unit_test (sorted-unique-vector-test unit/sorted-unique-vector-test.cpp)
injeqt_add_unit_test (type-dependencies-test unit/type-dependencies-test.cpp)
injeqt_add_unit_test (type-test unit/type-test.cpp)
injeqt_add_unit_test (type-relations-test unit/type-relations-test.cpp)
injeqt_add_unit_test (types-by-name-test unit/types-by-name-test.cpp)
injeqt_add_unit_test (types-model-test unit/types-model-test.cpp)

injeqt_add_integration_test (default-constructor-behavior-test integration/default-constructor-behavior-test.cpp)
injeqt_add_integration_test (factory-behavior-test integration/factory-behavior-test.cpp)
injeqt_add_integration_test (ready-object-behavior-test integration/ready-object-behavior-test.cpp)

=== debian/changelog ===
injeqt (1.0.1-1) unstable; urgency=low

  * Initial release (Closes: #792170)

 -- Patryk Cisek <patryk@debian.org>  Sun, 12 Jul 2015 16:16:07 +0200

=== debian/control ===
Source: injeqt
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               qtbase5-dev
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/vogel/injeqt

Package: libinjeqt-dev
Section: libdevel
Architecture: any
Depends: libinjeqt0 (= ${binary:Version}), ${misc:Depends}
Description: Dependency injection framework for Qt
 Dependency injection is an implementation of inverse of control and can be
 used to increase program modularity and extendability. In general it also
 results in more testable source code.
 .
 There is a lot of dependency injection frameworks for bytecode based
 languages like Java and C#, for instance Guice and Spring. C++ lacks
 reflection facilities that make dependency injection so powerful in these
 languages.
 .
 Injeqt is an attempt to build a powerful and reliable dependency injection
 framework on Qt's reflection based on MOC (meta-object compiler). For
 version 0.1 some basic features were implemented.
 .
 This package contains development files needed to compile software, that
 uses the library.

Package: libinjeqt0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Dependency injection framework for Qt
 Dependency injection is an implementation of inverse of control and can be
 used to increase program modularity and extendability. In general it also
 results in more testable source code.
 .
 There is a lot of dependency injection frameworks for bytecode based
 languages like Java and C#, for instance Guice and Spring. C++ lacks
 reflection facilities that make dependency injection so powerful in these
 languages.
 .
 Injeqt is an attempt to build a powerful and reliable dependency injection
 framework on Qt's reflection based on MOC (meta-object compiler). For
 version 0.1 some basic features were implemented.
 .
 This package contains the library.

## injeqt 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,8 +21,8 @@
 project (injeqt)
 cmake_minimum_required (VERSION 2.8)
 
-set (INJEQT_SOVERSION "0")
-set (INJEQT_VERSION "1.0.1")
+set (INJEQT_SOVERSION "1")
+set (INJEQT_VERSION "1.1.0")
 
 option (DISABLE_TESTS "Do not build tests" OFF)
 option (DISABLE_EXAMPLES "Do not build examples" OFF)
@@ -39,11 +39,7 @@
 
 set (WARNINGS "-Werror -W -Wall -Wextra -Wundef -Wunused -Wuninitialized -Wcast-align -Wpointer-arith -Woverloaded-virtual -Wnon-virtual-dtor -fno-common")
 set (VISIBILITY "-fvisibility=hidden -fvisibility-inlines-hidden")
-set (CMAKE_CXX_FLAGS "-std=c++11 ${WARNINGS} ${VISIBILITY}")
-
-if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-	set (CMAKE_CXX_FLAGS "-O0 ${CMAKE_CXX_FLAGS}")
-endif (CMAKE_BUILD_TYPE STREQUAL "Debug")
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ${WARNINGS} ${VISIBILITY}")
 
 set (CMAKE_AUTOMOC TRUE)
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -59,10 +55,10 @@
 	add_subdirectory (examples)
 endif (NOT DISABLE_EXAMPLES)
 
-if (NOT DISABLE_TESTS)
+if (NOT CMAKE_BUILD_TYPE MATCHES RELEASE AND NOT DISABLE_TESTS)
 	enable_testing ()
 	add_subdirectory (test)
-endif (NOT DISABLE_TESTS)
+endif (NOT CMAKE_BUILD_TYPE MATCHES RELEASE AND NOT DISABLE_TESTS)
 
 if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
 	set (CMAKE_INSTALL_LIBDIR lib)

=== examples/CMakeLists.txt ===
#
# %injeqt copyright begin%
# Copyright 2014 Rafał Malinowski (rafal.przemyslaw.malinowski@gmail.com)
# %injeqt copyright end%
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

find_package(Qt5Test 5.2 REQUIRED)

include_directories(
	${CMAKE_SOURCE_DIR}/src
)

function (injeqt_add_example name_)
	file (RELATIVE_PATH sourcePath "${CMAKE_SOURCE_DIR}/examples" "${CMAKE_CURRENT_SOURCE_DIR}")

	get_filename_component (exeDir "${CMAKE_CURRENT_BINARY_DIR}/${name_}" PATH)
	file (MAKE_DIRECTORY "${exeDir}")

	add_executable (${name_} ${ARGN})
	target_link_libraries (${name_} injeqt)
	set_property (TARGET ${name_} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error")
	qt5_use_modules (${name_} Core)
endfunction ()

injeqt_add_example(hello-world-example hello-world.cpp)

=== test/CMakeLists.txt ===
#
# %injeqt copyright begin%
# Copyright 2014 Rafał Malinowski (rafal.przemyslaw.malinowski@gmail.com)
# %injeqt copyright end%
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

find_package (Qt5Test 5.2 REQUIRED)

option (DISABLE_COVERAGE "Do not gather coverage data" OFF)

include_directories (
	${CMAKE_SOURCE_DIR}/src
)

if (NOT DISABLE_COVERAGE)
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
	set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -O0")

	add_custom_target (coverage
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/coverage.sh
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endif (NOT DISABLE_COVERAGE)

function (injeqt_add_test name file)
	file (RELATIVE_PATH sourcePath "${CMAKE_SOURCE_DIR}/test" "${CMAKE_CURRENT_SOURCE_DIR}")

	get_filename_component (exeDir "${CMAKE_CURRENT_BINARY_DIR}/${name}" PATH)
	file (MAKE_DIRECTORY "${exeDir}")

	add_executable (${name} ${file})
	set_property (TARGET ${name} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error")
	qt5_use_modules (${name} Core Test)

	if (NOT DISABLE_COVERAGE)
		target_link_libraries (${name} gcov)
	endif (NOT DISABLE_COVERAGE)

	add_test ("${sourcePath}/${name}" ${name})
endfunction ()

function (injeqt_add_unit_test name)
	injeqt_add_test (${name} unit/${name}.cpp)
	target_link_libraries (${name} injeqt)
endfunction ()

function (injeqt_add_integration_test name)
	injeqt_add_test (${name} integration/${name}.cpp)
	target_link_libraries (${name} injeqt)
endfunction ()

set (UNIT_TESTS
	action-method-test
	default-constructor-method-test
	dependencies-test
	dependency-test
	factory-method-test
	implementation-test
	implemented-by-test
	injector-core-test
	injector-test
	interfaces-utils-test
	module-impl-test
	module-test
	provider-by-default-constructor-test
	provider-by-default-constructor-configuration-test
	provider-by-factory-test
	provider-by-factory-configuration-test
	provider-ready-test
	provider-ready-configuration-test
	required-to-satisfy-test
	resolved-dependency-test
	resolve-dependencies-test
	setter-method-test
	sorted-unique-vector-test
	type-dependencies-test
	type-relations-test
	type-role-test
	type-test
	types-by-name-test
	types-model-test
)

set (INTEGRATION_TESTS
	default-constructor-behavior-test
	duplicate-dependencies-test
	factory-behavior-test
	init-done-test
	inject-into-behavior-test
	inject-into-during-init-test
	instantiate-all-with-type-role-test
	ready-object-behavior-test
	super-sub-dependency-test
)

foreach (UNIT_TEST ${UNIT_TESTS})
	injeqt_add_unit_test (${UNIT_TEST})
endforeach ()

foreach (INTEGRATION_TEST ${INTEGRATION_TESTS})
	injeqt_add_integration_test (${INTEGRATION_TEST})
endforeach ()

=== debian/changelog ===
injeqt (1.1.0-1.1build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:22:57 +0000

injeqt (1.1.0-1.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:28:28 +0000

injeqt (1.1.0-1.1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:38:02 +0000

injeqt (1.1.0-1.1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:16:29 +0100

injeqt (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch to fix ftbfs with GCC-7. (Closes: #853452)

 -- Mateusz Łukasik <mati75@linuxmint.pl>  Fri, 18 Aug 2017 14:16:12 +0200

injeqt (1.1.0-1) unstable; urgency=medium

  * New upstream release

 -- Patryk Cisek <patryk@debian.org>  Fri, 25 Nov 2016 11:49:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: injeqt
 Priority: optional
-Maintainer: Patryk Cisek <patryk@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Patryk Cisek <patryk@debian.org>
 Build-Depends: debhelper (>= 9),
                cmake,
                qtbase5-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/vogel/injeqt
 
 Package: libinjeqt-dev
 Section: libdevel
 Architecture: any
-Depends: libinjeqt0 (= ${binary:Version}), ${misc:Depends}
+Depends: libinjeqt1 (= ${binary:Version}), ${misc:Depends}
 Description: Dependency injection framework for Qt
  Dependency injection is an implementation of inverse of control and can be
  used to increase program modularity and extendability. In general it also
@@ -29,7 +30,7 @@
  This package contains development files needed to compile software, that
  uses the library.
 
-Package: libinjeqt0
+Package: libinjeqt1
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Dependency injection framework for Qt

## injeqt 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 cmake_minimum_required (VERSION 2.8)
 
 set (INJEQT_SOVERSION "1")
-set (INJEQT_VERSION "1.1.0")
+set (INJEQT_VERSION "1.2")
 
 option (DISABLE_TESTS "Do not build tests" OFF)
 option (DISABLE_EXAMPLES "Do not build examples" OFF)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 	exception/exception.cpp
 	exception/instantiation-failed.cpp
 	exception/interface-not-implemented.cpp
+	exception/invalid-action.cpp
 	exception/invalid-dependency.cpp
 	exception/invalid-qobject.cpp
 	exception/invalid-setter.cpp
@@ -42,6 +43,7 @@
 	exception/unique-factory-method-not-found.cpp
 	exception/unresolvable-dependencies.cpp
 
+	internal/action-method.cpp
 	internal/default-constructor-method.cpp
 	internal/dependencies.cpp
 	internal/dependency.cpp
@@ -52,25 +54,36 @@
 	internal/injector-impl.cpp
 	internal/interfaces-utils.cpp
 	internal/module-impl.cpp
+	internal/provided-object.cpp
 	internal/provider-by-default-constructor.cpp
 	internal/provider-by-default-constructor-configuration.cpp
 	internal/provider-by-factory.cpp
 	internal/provider-by-factory-configuration.cpp
+	internal/provider-by-parent-injector.cpp
+	internal/provider-by-parent-injector-configuration.cpp
 	internal/provider-ready.cpp
 	internal/provider-ready-configuration.cpp
-	internal/required-to-instantiate.cpp
+	internal/required-to-satisfy.cpp
 	internal/resolved-dependency.cpp
 	internal/resolve-dependencies.cpp
 	internal/setter-method.cpp
 	internal/type-dependencies.cpp
 	internal/type-relations.cpp
+	internal/type-role.cpp
 	internal/types-by-name.cpp
 	internal/types-model.cpp
 )
 
-add_definitions (
-	-Dinjeqt_EXPORTS
-)
+add_definitions (-Dinjeqt_EXPORTS)
+if (NOT CMAKE_BUILD_TYPE MATCHES RELEASE AND NOT DISABLE_TESTS)
+	add_definitions (-Dinjeqt_INTERNAL_EXPORTS)
+
+	if (NOT DISABLE_COVERAGE)
+		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
+		set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -O0")
+		set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -O0")
+	endif (NOT DISABLE_COVERAGE)
+endif (NOT CMAKE_BUILD_TYPE MATCHES RELEASE AND NOT DISABLE_TESTS)
 
 add_library (
 	injeqt

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -99,6 +99,7 @@
 	default-constructor-behavior-test
 	duplicate-dependencies-test
 	factory-behavior-test
+	get-all-with-type-role-test
 	init-done-test
 	inject-into-behavior-test
 	inject-into-during-init-test

=== debian/changelog ===
injeqt (1.2.0-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix build with cmake 4 (Thanks for the hint to Adrian Bunk)
    Closes: #1113040
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2025 12:33:00 +0100

injeqt (1.2.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
    Closes: #1096099
  * New upstream version
    Closes: #1082342
  * Maintain in Package Salvage team
  * Add watch file
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Trim trailing whitespace.
  * d/rules: Remove unused template
  * Propagate hardening options
  * Drop unneeded debian/*.dirs files
  * d/copyright: review

 -- Andreas Tille <tille@debian.org>  Mon, 10 Mar 2025 09:37:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,24 @@
 Source: injeqt
+Standards-Version: 4.7.2
+Maintainer: Package Salvaging Team <team+salvage@tracker.debian.org>
+Uploaders:
+ Patryk Cisek <patryk@debian.org>,
+Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Patryk Cisek <patryk@debian.org>
-Build-Depends: debhelper (>= 9),
-               cmake,
-               qtbase5-dev
-Standards-Version: 3.9.8
-Section: libs
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ qtbase5-dev,
+Vcs-Browser: https://salsa.debian.org/debian/injeqt
+Vcs-Git: https://salsa.debian.org/debian/injeqt.git
 Homepage: https://github.com/vogel/injeqt
 
 Package: libinjeqt-dev
+Architecture: any
 Section: libdevel
-Architecture: any
-Depends: libinjeqt1 (= ${binary:Version}), ${misc:Depends}
+Depends:
+ libinjeqt1 (= ${binary:Version}),
+ ${misc:Depends},
 Description: Dependency injection framework for Qt
  Dependency injection is an implementation of inverse of control and can be
  used to increase program modularity and extendability. In general it also
@@ -32,7 +38,9 @@
 
 Package: libinjeqt1
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
 Description: Dependency injection framework for Qt
  Dependency injection is an implementation of inverse of control and can be
  used to increase program modularity and extendability. In general it also

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

=== debian/watch ===
Version: 5

Template: Github
Owner: vogel
Project: injeqt
